# Navcoin v4.7.0 Release Notes

## Added password prompt for CFund payment/proposal dialogs

<[Pull Request 474](https://github.com/navcoin/navcoin-core/pull/474)>
<[Commit aa4bbaa](https://github.com/navcoin/navcoin-core/commit/aa4bbaaf7a82600775065f6bab894f78583b9784)>

Peviously you would have to unlock the wallet via the console or debug window before it was possible to create a proposal or payment request through the graphical interface. Now there is a dialog to unlock the wallet while using the Community Fund GUI.


## Use of the CoinsDB for the Community Fund

<[Pull Request 487](https://github.com/navcoin/navcoin-core/pull/487)>
<[Commit a8f425b](https://github.com/navcoin/navcoin-core/commit/a8f425b9bd86147693c1e79427c39876425ac7cf)>

Previously the community fund data was stored in a seperate local database to the rest of the coin data. The data has now been migrated to be part of the CoinsDB which should increase performance and mitigate the data consistency issues that some users were experiencing.


## Added error log tab in debug window

<[Pull Request 466](https://github.com/navcoin/navcoin-core/pull/466)>
<[Commit bed76b9](https://github.com/navcoin/navcoin-core/commit/bed76b917b6590148a371d5a3d86d2a534ef1f3b)>

You can now see errors which are logged to the debug.log file in the debug window of navcoin-qt. Users no longer have to manually read or search the debug.log via command line to find error messages.

## Added some new FIAT currencies and enabled auto price update

<[Pull Request 469](https://github.com/navcoin/navcoin-core/pull/469)>
<[Commit 5ee24af](https://github.com/navcoin/navcoin-core/commit/5ee24afd29937cd7c12d538313783671318d1c87)>

30 Fiat can now be configured as the display units through of navcoin-qt. The issue causing the sockets polling for exchange rates not to close correctly has also been resolved which prevents the wallet from eventually crashing.

## Added new progress ui for sync

<[Pull Request 526](https://github.com/navcoin/navcoin-core/pull/526)>
<[Commit 42769b2](https://github.com/navcoin/navcoin-core/commit/42769b2352f1a33e5b4f8c2971e787b22b00ecb4)>

When the wallet starts and detects it is still catching up to the latest block a progress overlay will be presented to the user. The user can close the overlay but it is now clearer that the wallet is still syncing and the balances will be incorrect until syncing finishes.

## Full List of merged pull requests

- Build: Compatibility with boost 1.67 <[Pull Request 470](https://github.com/navcoin/navcoin-core/pull/470)> <[Commit 47ac15f](https://github.com/navcoin/navcoin-core/commit/47ac15f2fd8caa8ec15455be9742f8a897c13c49)>
- Adds OP_POOL to scripts <[Pull Request 464](https://github.com/navcoin/navcoin-core/pull/464)> <[Commit 0c57840](https://github.com/navcoin/navcoin-core/commit/0c578405233834a3b300666987cb8c3d2dd40f3b)>
- Added a short bash command for dependencies to build-unix.md <[Pull Request 452](https://github.com/navcoin/navcoin-core/pull/452)> <[Commit ddba46d](https://github.com/navcoin/navcoin-core/commit/ddba46d4f92b152a361e8783cd3e8f3d1b4fa41b)>
- Added the Navcoin Knowledge Base menu item <[Pull Request 454](https://github.com/navcoin/navcoin-core/pull/454)> <[Commit c9a1802](https://github.com/navcoin/navcoin-core/commit/c9a1802c1674b2e0014045b246818e3d4a77ad4a)>
- Currency Change now updates staking info as well <[Pull Request 453](https://github.com/navcoin/navcoin-core/pull/453)> <[Commit 4df0766](https://github.com/navcoin/navcoin-core/commit/4df0766fa8a34b928f8680d25b4928f5764288e2)>
- Removed some autogenerated files by QT <[Pull Request 462](https://github.com/navcoin/navcoin-core/pull/462)> <[Commit 8a638e9](https://github.com/navcoin/navcoin-core/commit/8a638e9edecf1ee7a2d571139eaa3f8fbc1eadfd)>
- Update copyright year and wallet version in clienversion.h <[Pull Request 475](https://github.com/navcoin/navcoin-core/pull/475)> <[Commit f00efb3](https://github.com/navcoin/navcoin-core/commit/f00efb3c4d4c3437ccccdb168fb1d43e68a9de66)>
- Added password prompt for CFund payment/proposal dialogs <[Pull Request 474](https://github.com/navcoin/navcoin-core/pull/474)> <[Commit aa4bbaa](https://github.com/navcoin/navcoin-core/commit/aa4bbaaf7a82600775065f6bab894f78583b9784)>
- Added new details for getstakinginfo error message <[Pull Request 472](https://github.com/navcoin/navcoin-core/pull/472)> <[Commit 4a62021](https://github.com/navcoin/navcoin-core/commit/4a620216be20493225267b6a6ef9c8d21f11a5e7)>
- Updated all references to old Repo Address for Navcoin github current url <[Pull Request 463](https://github.com/navcoin/navcoin-core/pull/463)> <[Commit f31382f](https://github.com/navcoin/navcoin-core/commit/f31382f824385c40e90c3ad10d4bca9655ce98df)>
- Updated the navcoin.ico file to use new art <[Pull Request 489](https://github.com/navcoin/navcoin-core/pull/XXX)> <[Commit e9275a0](https://github.com/navcoin/navcoin-core/commit/e9275a00ef80ece414539ca9d29569bc20294dc6)>
- Updated navcoin.icns file with new assets <[Pull Request 493](https://github.com/navcoin/navcoin-core/pull/493)> <[Commit 342e29b](https://github.com/navcoin/navcoin-core/commit/342e29b5d99aa42bbf3ae71f8ff92a1a843182d1)>
- Updated other ico files <[Pull Request 492](https://github.com/navcoin/navcoin-core/pull/492)> <[Commit 926c49a](https://github.com/navcoin/navcoin-core/commit/926c49a273189277afad6a3fa9f91be060682b3c)>
- Fix for importaddress returning incorrect amounts <[Pull Request 479](https://github.com/navcoin/navcoin-core/pull/479)> <[Commit b115c2d](https://github.com/navcoin/navcoin-core/commit/b115c2dd495dc28a87957b4104afe8cf78171b7a)>
- Added editorconfig file <[Pull Request 497](https://github.com/navcoin/navcoin-core/pull/497)> <[Commit f501b18](https://github.com/navcoin/navcoin-core/commit/f501b184662ea4ab8e7d0365df01ae094dcd4ecb)>
- Fix for Coin Control "sorting" bug <[Pull Request 461](https://github.com/navcoin/navcoin-core/pull/461)> <[Commit a4c8eb6](https://github.com/navcoin/navcoin-core/commit/a4c8eb6e670f701ba4401fce161ccae64f174486)>
- Use of the CoinsDB for the Community Fund <[Pull Request 487](https://github.com/navcoin/navcoin-core/pull/487)> <[Commit a8f425b](https://github.com/navcoin/navcoin-core/commit/a8f425b9bd86147693c1e79427c39876425ac7cf)>
- TX_POOL missing in switch condition in the IsMine function <[Pull Request 500](https://github.com/navcoin/navcoin-core/pull/500)> <[Commit 498e75f](https://github.com/navcoin/navcoin-core/commit/498e75f2b915bf5d8fccc10c1080ed68b478fceb)>
- Fixed some file permissions <[Pull Request 502](https://github.com/navcoin/navcoin-core/pull/502)> <[Commit 7fac091](https://github.com/navcoin/navcoin-core/commit/7fac091ff95382c44544aa4c8d23109c370a9bd1)>
- Added error log tab in debug window <[Pull Request 466](https://github.com/navcoin/navcoin-core/pull/466)> <[Commit bed76b9](https://github.com/navcoin/navcoin-core/commit/bed76b917b6590148a371d5a3d86d2a534ef1f3b)>
- Fix RPC Tests <[Pull Request 480](https://github.com/navcoin/navcoin-core/pull/480)> <[Commit c2855a7](https://github.com/navcoin/navcoin-core/commit/c2855a73c8f4ea6395c440bc65d5fff2ab1cfeb3)>
- Fixed a bug with the errorLogFile causing crashes <[Pull Request 507](https://github.com/navcoin/navcoin-core/pull/507)> <[Commit 9f40cbd](https://github.com/navcoin/navcoin-core/commit/9f40cbd071f4c68efc70182133ab2d094823226d)>
- Prevent segfault on gui close <[Pull Request 505](https://github.com/navcoin/navcoin-core/pull/505)> <[Commit d4b23bf](https://github.com/navcoin/navcoin-core/commit/d4b23bf13033b7603b62ba6bb6d5e8ca387ba3d3)>
- Remove Bootstrap option from GUI <[Pull Request 512](https://github.com/navcoin/navcoin-core/pull/512)> <[Commit 79624cf](https://github.com/navcoin/navcoin-core/commit/79624cfc0806a1cf46e0ab02b8b351f339c2c146)>
- Use `-rescan` when `-importmnemonic` <[Pull Request 494](https://github.com/navcoin/navcoin-core/pull/494)> <[Commit e061768](https://github.com/navcoin/navcoin-core/commit/e0617681629779afa10224c92e9b45713b54b410)>
- Creates default config file <[Pull Request 504](https://github.com/navcoin/navcoin-core/pull/504)> <[Commit 940c669](https://github.com/navcoin/navcoin-core/commit/940c669b9a717b9bb82fe5f2acbf9f9457a6e8f2)>
- Changes required for GLIBC backward compatibility with gitian builds <[Pull Request 501](https://github.com/navcoin/navcoin-core/pull/501)> <[Commit d3b5687](https://github.com/navcoin/navcoin-core/commit/d3b56870eba55fbd2a0e323af6651f47d31e8b64)>
- Fix potential deadlock <[Pull Request 506](https://github.com/navcoin/navcoin-core/pull/506)> <[Commit de6e167](https://github.com/navcoin/navcoin-core/commit/de6e167511381b5259d58518a69a48ea72417071)>
- Moved the checkboxes into the empty QGroupBox <[Pull Request 484](https://github.com/navcoin/navcoin-core/pull/484)> <[Commit 4fb8043](https://github.com/navcoin/navcoin-core/commit/4fb8043f068fae1814ff76049a45f237b4df6f8e)>
- Added new attributes to the `getstakinginfo` and `getstakereport` commands <[Pull Request 485](https://github.com/navcoin/navcoin-core/pull/485)> <[Commit 82a2ba8](https://github.com/navcoin/navcoin-core/commit/82a2ba8aaae4fa6a7007f8efcb1842609fad70f5)>
- Added some new FIAT currencies and enabled auto price update <[Pull Request 469](https://github.com/navcoin/navcoin-core/pull/469)> <[Commit 5ee24af](https://github.com/navcoin/navcoin-core/commit/5ee24afd29937cd7c12d538313783671318d1c87)>
- OSX DMG and Mac Deploy bug fixes <[Pull Request 514](https://github.com/navcoin/navcoin-core/pull/514)> <[Commit e393fe4](https://github.com/navcoin/navcoin-core/commit/e393fe494b7c44d1dc61fa6c5f046cec3e134009)>
- Updated ./src/univalue from upstream <[Pull Request 524](https://github.com/navcoin/navcoin-core/pull/524)> <[Commit 4ff2780](https://github.com/navcoin/navcoin-core/commit/4ff2780dd838b9be6d1f4544a1d1e973ff68130e)>
- Added new progress ui for sync <[Pull Request 526](https://github.com/navcoin/navcoin-core/pull/526)> <[Commit 42769b2](https://github.com/navcoin/navcoin-core/commit/42769b2352f1a33e5b4f8c2971e787b22b00ecb4)>
- Make some tests more reliable  <[Pull Request 537](https://github.com/navcoin/navcoin-core/pull/537)> <[Commit 8c4b490](https://github.com/navcoin/navcoin-core/commit/8c4b490fddea29598cc23a90a32687c5e4afd260)>
- Fixed some more file permissions <[Pull Request 533](https://github.com/navcoin/navcoin-core/pull/533)> <[Commit baa66eb](https://github.com/navcoin/navcoin-core/commit/baa66ebbf88a49c1a2099c9955a1a80b940c0969)>
- Move nBits check to ContextualCheckBlock <[Pull Request 517](https://github.com/navcoin/navcoin-core/pull/517)> <[Commit a16c48f](https://github.com/navcoin/navcoin-core/commit/a16c48f317b5dca9fce2394f70f840c59fd20228)>
- Updated the error log tab logic <[Pull Request 532](https://github.com/navcoin/navcoin-core/pull/532)> <[Commit a4f23ac](https://github.com/navcoin/navcoin-core/commit/a4f23acbc291c789ab819d38bfdf56698c88dcef)>
- Check node address in header spam protection <[Pull Request 536](https://github.com/navcoin/navcoin-core/pull/536)> <[Commit 45c98d5](https://github.com/navcoin/navcoin-core/commit/45c98d56f56a4fd706deca1594d774e49d7dadb1)>
- Revert nBits patch <[Pull Request 544](https://github.com/navcoin/navcoin-core/pull/544)> <[Commit ab51282](https://github.com/navcoin/navcoin-core/commit/ab51282efee7b66f1ee1520c3b965567d3e0f6a4)>
- Updated __poll_chk implementation to be not so strict <[Pull Request 549](https://github.com/navcoin/navcoin-core/pull/549)> <[Commit ee83269](https://github.com/navcoin/navcoin-core/commit/ee832697b981077a591a0c2d2a8df64f4fda9651)>
- Added an additional LOCK for cs_main <[Pull Request 558](https://github.com/navcoin/navcoin-core/pull/558)> <[Commit ac5df35](https://github.com/navcoin/navcoin-core/commit/ac5df354f3b9c961a60b581284c1748a275bef5d)>
- Added an additional LOCK for cs_main <[Pull Request 558](https://github.com/navcoin/navcoin-core/pull/558)> <[Commit ac5df35](https://github.com/navcoin/navcoin-core/commit/ac5df354f3b9c961a60b581284c1748a275bef5d)>
- new SVG icons <[Pull Request 555](https://github.com/navcoin/navcoin-core/pull/555)> <[Commit 9619bc4](https://github.com/navcoin/navcoin-core/commit/9619bc4352af42ab9234664d5836ede23294a69c)>
- Added a lock before we call GetTxStakeAmount() <[Pull Request 564](https://github.com/navcoin/navcoin-core/pull/564)> <[Commit bfeb225](https://github.com/navcoin/navcoin-core/commit/bfeb22567f7a77e65431ccc3802cdc925428709d)>
- Fixed crash when selecting a currency with no price data <[Pull Request 571](https://github.com/navcoin/navcoin-core/pull/571)> <[Commit 4337157](https://github.com/navcoin/navcoin-core/commit/43371570b5060960ae92c2b22b53355d931ce45f)>
- vector logo and icon <[Pull Request 575](https://github.com/navcoin/navcoin-core/pull/575)> <[Commit 8cb91db](https://github.com/navcoin/navcoin-core/commit/8cb91dbe3b17a655020a47c221ea123ca46c3cf9)>
- Added a lock (Crashed the wallet when voting from details dialog) <[Pull Request 577](https://github.com/navcoin/navcoin-core/pull/577)> <[Commit f2b924e](https://github.com/navcoin/navcoin-core/commit/f2b924ef59cf2ae19fa8106ca3b71c5e7cd0a2c3)>
- Updated a lock on LoadWallet to fix a crash on wallet rescan <[Pull Request 582](https://github.com/navcoin/navcoin-core/pull/582)> <[Commit 06109e8](https://github.com/navcoin/navcoin-core/commit/06109e8356ebf741a7c9701adde1a20d234e5c1c)>
- Coldstaking pool fee <[Pull Request 523](https://github.com/navcoin/navcoin-core/pull/523)> <[Commit f449aec](https://github.com/navcoin/navcoin-core/commit/f449aeca138273151ded55b2ec14f9c97ca3f3dd)>
- OSX pink menu bug <[Pull Request 589](https://github.com/navcoin/navcoin-core/pull/589)> <[Commit e087919](https://github.com/navcoin/navcoin-core/commit/e0879195bdf5373e5b1fcf4e970af0a8815660f6)>
