#ifndef QJSONMODEL_H
#define QJSONMODEL_H

#include "qjsonitem.h"

#include <QAbstractItemModel>
#include <QJsonDocument>
#include <QJsonObject>
#include <QIcon>

class QJsonModel : public QAbstractItemModel
{
    Q_OBJECT

public:
    QJsonModel(QObject *parent = 0);
    QJsonModel(QString h1, QString h2);
    bool load(const QString& fileName);
    bool load(QIODevice * device);
    bool loadJson(const QByteArray& json);
    QVariant data(const QModelIndex &index, int role) const;
    QVariant headerData(int section, Qt::Orientation orientation, int role) const;
    QModelIndex index(int row, int column,const QModelIndex &parent = QModelIndex()) const;
    QModelIndex parent(const QModelIndex &index) const;
    int rowCount(const QModelIndex &parent = QModelIndex()) const;
    int columnCount(const QModelIndex &parent = QModelIndex()) const;
    void setIcon(const QJsonValue::Type& type, const QIcon& icon);

private:
    QJsonTreeItem * mRootItem;
    QJsonDocument mDocument;
    QStringList mHeaders;
    QHash<QJsonValue::Type, QIcon> mTypeIcons;


};

#endif // QJSONMODEL_H
